function M = centering(M)

PLOT = false;
n = length(M);
if PLOT, figure(2); imagesc(M); end
S = mean(M,2);
M = M - S*ones(1,n) - ones(n,1)*S' + mean(S);
M = M / mean(diag(M));
if PLOT, figure(3); imagesc(M); end

%Numerical problems result in non-symmetricalities on the order of 10^-17
%in some cases.
M = (M + M')/2;

%some minor normalization.
M = n * M ./ sum(diag(M));
M = M - min(min(M));

end